#include <assert.h>
#include <string.h>

#define WORDS 26
#define BITS_IN_WORD 31

void _ROR_old(int *buf, int cnt)
{
        unsigned char tbl[BITS_IN_WORD*WORDS]; // 31 bits in each word. 8 words.
        unsigned char tbl2[BITS_IN_WORD*WORDS]; // 31 bits in each word. 8 words.

        //for (int i=0; i<8; i++)
        //        printf ("line %d cnt=%d i=%d buf[i]=0x%08x\n", __LINE__, cnt, i, buf[i]);

        for (int i=0; i<WORDS; i++)
                for (int j=0; j<BITS_IN_WORD; j++)
                       tbl[i*BITS_IN_WORD+j]=(buf[i]>>j)&1;

        for (int i=0; i<BITS_IN_WORD*WORDS; i++)
                tbl2[(i+cnt) % (BITS_IN_WORD*WORDS)]=tbl[i];

        for (int i=0; i<WORDS; i++)
        {
                buf[i]=0;
                for (int j=0; j<BITS_IN_WORD; j++)
                {
                        if (tbl2[i*BITS_IN_WORD+j])
                                buf[i]=buf[i] | (1<<j);
                        else
                                buf[i]=buf[i] & (~(1<<j));
                };
        };

        //for (int i=0; i<8; i++)
        //        printf ("line %d cnt=%d i=%d buf[i]=0x%08x\n", __LINE__, cnt, i, buf[i]);
};

void _ROR(int *ECX_this, int cnt)
{
        int *v2; // esi
        int v3; // ebx
        //signed int v4; // eax
        int v5; // eax
        int v6; // edi
        int *v7; // edx
        int *v8; // ecx
        int v9; // ebp
        int v10; // edx
        int v11; // edx

        v2 = ECX_this;
        v3 = cnt;
        if ( cnt > BITS_IN_WORD )
        {
                v5 = v3 / BITS_IN_WORD;
                v6 = WORDS - v3 / BITS_IN_WORD;
                v3 %= BITS_IN_WORD;
                v7 = ECX_this + WORDS;
                v8 = &ECX_this[v6];
                for (; v6>0; )
                {
                        v9 = *(v8 - 1);
                        --v8;
                        --v7;
                        --v6;
                        *v7 = v9;
                }
                for ( ; v5 > 0; v2[v5] = 0 )
                        --v5;
        }
        // busy loop
        int v4=WORDS;
        do
        {
                v10 = v2[v4-- - 1];
                v11 = (v10 << v3) & 0x7FFFFFFF;
                if ( v4 > 0 )
                        v11 |= (unsigned int)v2[v4 - 1] >> (BITS_IN_WORD - v3);
                v2[v4] = v11;
        }
        while ( v4 > 0 );
}

void _ROL_old(int *buf, int cnt)
{
        unsigned char tbl[BITS_IN_WORD*WORDS]; // 31 bits in each word. 8 words.
        unsigned char tbl2[BITS_IN_WORD*WORDS]; // 31 bits in each word. 8 words.

        //for (int i=0; i<8; i++)
        //        printf ("line %d cnt=%d i=%d buf[i]=0x%08x\n", __LINE__, cnt, i, buf[i]);

        for (int i=0; i<WORDS; i++)
                for (int j=0; j<BITS_IN_WORD; j++)
                       tbl[i*BITS_IN_WORD+j]=(buf[i]>>j)&1;

        for (int i=0; i<BITS_IN_WORD*WORDS; i++)
                tbl2[i]=tbl[(i+cnt) % (BITS_IN_WORD*WORDS)];

        for (int i=0; i<WORDS; i++)
        {
                buf[i]=0;
                for (int j=0; j<BITS_IN_WORD; j++)
                {
                        if (tbl2[i*BITS_IN_WORD+j])
                                buf[i]=buf[i] | (1<<j);
                        else
                                buf[i]=buf[i] & (~(1<<j));
                };
        };

        //for (int i=0; i<8; i++)
        //        printf ("line %d cnt=%d i=%d buf[i]=0x%08x\n", __LINE__, cnt, i, buf[i]);
};

void _ROL(unsigned int* ECX, int cnt)
{
        unsigned  int* th=ECX;

        int v2; // esi
        unsigned int *v3; // ebp
        unsigned int *v5; // edi
        int v6; // ecx
        int v7; // eax
        unsigned int v8; // eax

        v2 = cnt;
        v3 = th;
        v5 = th;
        if ( cnt > BITS_IN_WORD )
        {
                v6 = v2 / BITS_IN_WORD;
                v7 = WORDS - v2 / BITS_IN_WORD;
                for ( v2 %= BITS_IN_WORD; v7 > 0; ++v5 )
                {
                        --v7;
                        *v5 = v5[v6];
                }
                if ( v6 > 0 )
                        memset(v5, 0, 4 * v6);
                v5 = v3;
        }
        // busy loop
        for (int v4=WORDS; v4>0 ;)
        {
                --v4;
                v8 = *v5 >> v2;
                if ( v4 > 0 )
                        v8 |= (v5[1] << (BITS_IN_WORD - v2)) & 0x7FFFFFFF;
                *v5 = v8;
                ++v5;
        }
}

void func_464FF0_ascii_code_to_buf(unsigned int* ECX, const char* const lic_code)
{
        const char *v2; // ebx
        int *v3; // esi
        int v4; // edi
        int v5; // eax

        v2 = lic_code;
        v3 = ECX;
        for (int i=0; i<WORDS; i++)
                v3[i] = 0;
#if 0
        printf ("%s() start\n", __FUNCTION__);
        printf ("%s() ECX:\n", __FUNCTION__);
        print_buf_ofs(ECX, WORDS*4, 0);
#endif
        v4 = *v2;
        for (; *v2 ; )
        {
                ++v2;
                _ROR(ECX, 4);
                v5 = v4 - '0';
                if ( (unsigned int)(v4 - '0') > 9 )
                {
                        if ( (unsigned int)(v4 - 'a') > 5 )
                        {
                                if ( (unsigned int)(v4 - 'A') > 5 )
                                        v5 = 0;
                                else
                                        v5 = v4 - '7';
                        }
                        else
                        {
                                v5 = v4 - 'W';
                        }
                }
                *v3 |= v5;
                v4 = *v2;
        }
#if 0
        printf ("%s() end \n", __FUNCTION__);
        printf ("%s() ECX:\n", __FUNCTION__);
        print_buf_ofs(ECX, WORDS*4, 0);
#endif
}

// possibly compare two 'bignums'
int func_4650D0_compare(const int* const th, const int* const a2)
{
	unsigned int t[WORDS];

	unsigned int prev=0;
	for (int i=0; i<WORDS; i++)
	{
		t[i]=(th[i] - prev - a2[i]) >> BITS_IN_WORD;
		prev=t[i];
	};
        //return t[WORDS-1] != 0;
	return prev != 0;
}

// th - changes
// a2 - const
// both - 8 integers
// SUBTRACT something to THIS?
void func_SUBTRACT(unsigned int* th, const unsigned int* const a2)
{
#if 0
        printf ("%s() begin\n", __FUNCTION__);
        printf ("%s() th:\n", __FUNCTION__);
        print_buf_ofs(th, WORDS*4, 0);
        printf ("%s() a2:\n", __FUNCTION__);
        print_buf_ofs(a2, WORDS*4, 0);
#endif
        unsigned int diffs[WORDS];
        unsigned int diffs_MSB[WORDS];
#if 0
        diffs[0] = th[0] - 0 - a2[0];
        diffs_MSB[0] = diffs[0] >> 31;
        th[0] = diffs[0] & 0x7FFFFFFF;

        diffs[1] = th[1] - diffs_MSB[0] - a2[1];
        diffs_MSB[1] = diffs[1] >> 31;
        th[1] = diffs[1] & 0x7FFFFFFF;

        diffs[2] = th[2] - diffs_MSB[1] - a2[2];
        diffs_MSB[2] = diffs[2] >> 31;
        th[2] = diffs[2] & 0x7FFFFFFF;

        diffs[3] = th[3] - diffs_MSB[2] - a2[3];
        diffs_MSB[3] = diffs[3] >> 31;
        th[3] = diffs[3] & 0x7FFFFFFF;

        diffs[4] = th[4] - diffs_MSB[3] - a2[4];
        diffs_MSB[4] = diffs[4] >> 31;
        th[4] = diffs[4] & 0x7FFFFFFF;

        diffs[5] = th[5] - diffs_MSB[4] - a2[5];
        diffs_MSB[5] = diffs[5] >> 31;
        th[5] = diffs[5] & 0x7FFFFFFF;

        diffs[6] = th[6] - diffs_MSB[5] - a2[6];
        diffs_MSB[6] = diffs[6] >> 31;
        th[6] = diffs[6] & 0x7FFFFFFF;

        diffs[7] = th[7] - diffs_MSB[6] - a2[7];
        // NOT USED:
        //diffs_MSB[7] = diffs[7] >> 31;
        th[7] = diffs[7] & 0x7FFFFFFF;
#endif
#if 1
        for (int i=0; i<WORDS; i++)
        {
                if (i==0)
                        diffs[i] = th[i] - 0 - a2[i];
                else
                        diffs[i] = th[i] - diffs_MSB[i-1] - a2[i];
                diffs_MSB[i] = diffs[i] >> BITS_IN_WORD;
                th[i] = diffs[i] & 0x7FFFFFFF;
        };
#endif        
#if 0
        printf ("%s() end\n", __FUNCTION__);
        printf ("%s() th:\n", __FUNCTION__);
        print_buf_ofs(th, WORDS*4, 0);
        printf ("%s() a2:\n", __FUNCTION__);
        print_buf_ofs(a2, WORDS*4, 0);
#endif
}

// TODO: use BSR?
int func_464B70_find_last_bit_old(const unsigned int* const th)
{
        unsigned char tbl[BITS_IN_WORD*WORDS]; // 31 bits in each word. 8 words.

        //for (int i=0; i<8; i++)
        //        printf ("line %d i=%d th[i]=0x%08x\n", __LINE__, i, th[i]);

        for (int i=0; i<WORDS; i++)
                for (int j=0; j<BITS_IN_WORD; j++)
                       tbl[i*BITS_IN_WORD+j]=(th[i]>>j)&1;

        for (int i=WORDS*BITS_IN_WORD; i>=0; i--)
                if (tbl[i])
                        return i;
        assert (0); // never reach
}

// seeking for a first bit in $th$? starting at the last 32-bit word, highest bit is 7th. not 8th
int func_464B70_find_last_bit (const unsigned int* const ECX)
{
        unsigned int v2; // edx
        const unsigned int* v3; // ecx
        const unsigned int* th=ECX;

        v2 = 0x40000000;
        v3 = th + (WORDS-1);
        //int i=0;

        int result;
//        for (result=248; ; )
        for (result=WORDS*BITS_IN_WORD; ; )
        {
                --result;
                if ( v2 & *v3 )
                        break;
                v2 >>= 1;
                if ( !v2 )
                {
                        --v3;
                        v2 = 0x40000000;
                }
                if ( result <= 0 )
                        return -1;
                //i++;
        }

        return result;
}

// ADD something to THIS
void func_ADD(unsigned int *th, const unsigned int* const a2)
{
#if 0
        unsigned int v5; // ecx
        unsigned int v6; // ecx
        unsigned int v7; // ecx
        unsigned int v8; // ecx
        unsigned int v9; // ecx
#endif
        //printf ("\n");
        //for (int i=0; i<8; i++)
        //        printf ("line %d th[i]=0x%08x\n", __LINE__, th[i]);
        //for (int i=0; i<8; i++)
        //        printf ("line %d a2[i]=0x%08x\n", __LINE__, a2[i]);

        unsigned sums[WORDS];
#if 0
        sums[0] = th[0] + a2[0];
        th[0] = sums[0] & 0x7FFFFFFF;

        sums[1] = th[1] + a2[1] + (sums[0] >> 31);
        th[1] = sums[1] & 0x7FFFFFFF;

        v5 = th[2] + a2[2] + (sums[1] >> 31);
        th[2] = v5 & 0x7FFFFFFF;
        v6 = th[3] + a2[3] + (v5 >> 31);
        th[3] = v6 & 0x7FFFFFFF;
        v7 = th[4] + a2[4] + (v6 >> 31);
        th[4] = v7 & 0x7FFFFFFF;
        v8 = th[5] + a2[5] + (v7 >> 31);
        th[5] = v8 & 0x7FFFFFFF;
        v9 = th[6] + a2[6] + (v8 >> 31);
        th[6] = v9 & 0x7FFFFFFF;
        unsigned int v10=th[7] + a2[7] + (v9 >> 31);
        th[7] = v10 & 0x7FFFFFFF;
#endif

        for (int i=0; i<WORDS; i++)
        {
                if (i==0)
                        sums[i] = th[i] + a2[i];
                else
                        sums[i] = th[i] + a2[i] + (sums[i-1] >> BITS_IN_WORD);
                th[i] = sums[i] & 0x7FFFFFFF;
        };
        //for (int i=0; i<8; i++)
        //        printf ("line %d th[i]=0x%08x\n", __LINE__, th[i]);
}

// a0=multiplier
// a1=product (result)
// a2=multiplicand
void func_465430_mul(
                const int* const a0,
                int *a1,
                const int* const a2)
{
#if 0
        for (int i=0; i<8; i++)
                printf ("line %d this_ECX[i]=0x%08x\n", __LINE__, this_ECX[i]);
        for (int i=0; i<8; i++)
                printf ("line %d arg0[i]=0x%08x\n", __LINE__, arg0[i]);
        for (int i=0; i<8; i++)
                printf ("line %d a2[i]=0x%08x\n", __LINE__, a2[i]);
#endif
        int mask_v6 = 0x40000000;
        memset((int*)a1, 0, WORDS*4);

        const int* a0_ptr = a0 + (WORDS-1);

        //for (int i=248; i>0 ; i--)
        for (int i=WORDS*BITS_IN_WORD; i>0 ; i--)
        {
                _ROR((int *)a1, 1);
                if ( mask_v6 & *a0_ptr )
                {
                        func_ADD(a1, a2);
                };
                mask_v6 >>= 1;
                if ( mask_v6==0 )
                {
                        --a0_ptr;
                        mask_v6 = 0x40000000;
                }
        }
}

// a1=divident (input)
// a2=remainder!
// a3=divisor
void func_465560_divide(int *a1, int *a2, const int* const a3)
{
        int a1_last_bit = func_464B70_find_last_bit(a1);
        int a3_last_bit = func_464B70_find_last_bit(a3); // can be cached = 123

        int a3_a2_last_bits_diff = a1_last_bit - a3_last_bit;
        memcpy (a2, a1, WORDS*4);

        int cond=a1_last_bit >= 0 && a3_last_bit >= 0 && a3_a2_last_bits_diff >= 0;
        if (cond==0)
                return;

        //memset((unsigned int*)v12, 0, 8*4);
        int a3_copy[WORDS];
        memcpy (a3_copy, a3, WORDS*4);
        _ROR(a3_copy, a3_a2_last_bits_diff); // align?!

        for ( ; a3_a2_last_bits_diff>=0; a3_a2_last_bits_diff--)
        {
                //ROL((int *)v12, 1); // NOT USED
                if ( func_4650D0_compare(a2, a3_copy)==0 ) // returns bool. 1 if v11>v7, 0 if v11<=v7
                {
                        // a2<=a3_copy here
                        //v12[0] |= 1u; // NOT USED. quotient?!
			// это надо оставить для демы!
                        func_SUBTRACT(a2, a3_copy);
                }
                _ROL(a3_copy, 1);
        }
        //return a2;
}

// AKA PowerMod
// https://reference.wolfram.com/language/ref/PowerMod.html
// a2=(lic^a3) % a4
// a1=input lic
// a2=? output
// power=hardcoded hex number like "abcde1111111111111"
// modulo=hardcoded hex number like "abcde11111111111111111111111111"
void powermod(
                const int* const x,
                int *a2_out,
                const int* const power,
                const int* const modulo)
{
        int power_last_bit = func_464B70_find_last_bit(power); //v4=68; // can be cached!

        int mask_v5 = 1 << power_last_bit % BITS_IN_WORD;
        memset(a2_out, 0, WORDS*4);
        a2_out[0]=1; // a2_out=1

        //v6 = &a3[v4 / 31];
        const unsigned int const *power_ptr = power + (power_last_bit / BITS_IN_WORD);

        for (; power_last_bit>=0; power_last_bit--)
        {
                int tmp[WORDS];
                // a2_out = (a2_out * a2_out) % modulo
                // a2_out = (a2_out << 1) % modulo
                func_465430_mul(a2_out, tmp, a2_out); // multiplier, product, multiplicand
                func_465560_divide(tmp, a2_out, modulo); // divident, remainder, divisor

                // if bit in *power_ptr is set:
                if ( mask_v5 & *power_ptr )
                {
                        int tmp[WORDS];
                        // a2_out = (a2_out * x) % modulo
                        func_465430_mul(x, tmp, a2_out); // multiplier, product, multiplicand
                        func_465560_divide(tmp, a2_out, modulo); // divident, remainder, divisor
                }
                mask_v5 >>= 1;
                if ( mask_v5==0 )
                {
                        --power_ptr;
                        mask_v5 = 0x40000000;
                }
        }
}

// TODO optimize this:
void get_bytes_from_bignum(unsigned int *_ECX, unsigned char *arg0, int a2)
{
        int a2_i; // esi
        unsigned char *arg0_i; // edi
        unsigned int this_2[WORDS]; // [esp+4h] [ebp-20h]

        //printf ("%s(a2=%d)\n", __FUNCTION__, a2);
        //assert (a2==15); // often!

        memcpy(&this_2[0], _ECX, WORDS*4);
        for (int j=0; j<a2; j++)
        {
                arg0[j] = (unsigned char)this_2[0];
                _ROL(this_2, sizeof(unsigned char)*8);
        }
}
// *** my code starts!

// almost works, but not used
#if 0
void set_bytes_to_bignum(unsigned int *out, unsigned char *input, int len)
{
        //unsigned char *arg0_i; // edi
        unsigned int buf[8]; // [esp+4h] [ebp-20h]

	memset(buf, 0, sizeof(buf));

        for (int j=0; j<len; j++)
        {
		_ROR(buf,8);
                buf[0]|=input[j];
        }

	memcpy (out, buf, sizeof(buf));
}
#endif

